Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# TAO_DIOP_Profile Class Reference

This class defines the protocol specific attributes required for locating ORBs over a TCP/IP network. More...

`#include <DIOP_Profile.h>`

Inheritance diagram for TAO_DIOP_Profile:

[legend]
Collaboration diagram for TAO_DIOP_Profile:

[legend]
List of all members.

## Public Methods
virtual char | object_key_delimiter (void) const
| TAO_DIOP_Profile (const ACE_INET_Addr &addr, const TAO_ObjectKey &object_key, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core)
| Profile constructor, same as above except the object_key has already been marshaled. More...
| TAO_DIOP_Profile (const char *host, CORBA::UShort port, const TAO_ObjectKey &object_key, const ACE_INET_Addr &addr, const TAO_GIOP_Message_Version &version, TAO_ORB_Core *orb_core)
| Profile constructor, this is the most efficient since it doesn't require any address resolution processing. More...
| TAO_DIOP_Profile (TAO_ORB_Core *orb_core)
| Profile constructor, default. More...
| ~TAO_DIOP_Profile (void)
| Destructor is to be called only through <_decr_refcnt>. More...
virtual void | parse_string (const char *string ACE_ENV_ARG_DECL)
| Initialize this object using the given input string. Url-style string contain only one endpoint. More...
virtual char * | to_string (ACE_ENV_SINGLE_ARG_DECL)
| Return a string representation for this profile. More...
virtual int | decode (TAO_InputCDR &cdr)
| Initialize this object using the given CDR octet string. More...
virtual int | encode (TAO_OutputCDR &stream) const
| Encode this profile in a stream, i.e. marshal it. More...
virtual int | encode_endpoints (void)
| Encodes this profile's endpoints into a tagged component. More...
virtual const TAO_ObjectKey & | object_key (void) const
| Deprecated: Return a reference to the Object Key. More...
virtual TAO_ObjectKey * | _key (void) const
| Return a pointer to the Object Key. The caller owns the memory allocated for the returned key. More...
virtual TAO_Endpoint * | endpoint (void)
| Return pointer to the head of this profile's endpoints list. More...
virtual size_t | endpoint_count (void)
| Return how many endpoints this profile contains. More...
void | add_endpoint (TAO_DIOP_Endpoint *endp)
| Add <end. More...
virtual CORBA::Boolean | is_equivalent (const TAO_Profile *other_profile)
| Return true if this profile is equivalent to other_profile. More...
virtual CORBA::ULong | hash (CORBA::ULong max ACE_ENV_ARG_DECL)
| Return a hash value for this object. More...
virtual IOP::TaggedProfile & | create_tagged_profile (void)
| Please refer to Profile.h for the documentation of this function. More...
## Static Public Methods
const char * | prefix (void)
| Return the char string prefix. More...
## Static Public Attributes
const char | object_key_delimiter_ = '/'
| The object key delimiter that DIOP uses or expects. More...
## Protected Attributes
TAO_DIOP_Endpoint | endpoint_
| Head of this profile's list of endpoints. More...
size_t | count_
| Number of endpoints in the list headed by <endpoint_>. More...
## Private Methods
void | create_profile_body (TAO_OutputCDR &cdr) const
| Creates an encapsulation of the ProfileBody struct in the <cdr>. More...
int | decode_endpoints (void)
| Helper for <decode>. More...
## Private Attributes
TAO_ObjectKey | object_key_
| Object_key associated with this profile. More...
IOP::TaggedProfile | tagged_profile_
| Our tagged profile. More...

## Detailed Description

This class defines the protocol specific attributes required for locating ORBs over a TCP/IP network.

This class defines the DIOP profile as specified in the CORBA specification.

## Constructor & Destructor Documentation

TAO_DIOP_Profile::TAO_DIOP_Profile | ( | const ACE_INET_Addr & | addr,
|  | const TAO_ObjectKey & | object_key,
|  | const TAO_GIOP_Message_Version & | version,
|  | TAO_ORB_Core * | orb_core
| ) |

| Profile constructor, same as above except the object_key has already been marshaled.

TAO_DIOP_Profile::TAO_DIOP_Profile | ( | const char * | host,
|  | CORBA::UShort | port,
|  | const TAO_ObjectKey & | object_key,
|  | const ACE_INET_Addr & | addr,
|  | const TAO_GIOP_Message_Version & | version,
|  | TAO_ORB_Core * | orb_core
| ) |

| Profile constructor, this is the most efficient since it doesn't require any address resolution processing.

TAO_DIOP_Profile::TAO_DIOP_Profile | ( | TAO_ORB_Core * | orb_core | ) |

| Profile constructor, default.

TAO_DIOP_Profile::~TAO_DIOP_Profile | ( | void |  | ) |

| Destructor is to be called only through <_decr_refcnt>.

## Member Function Documentation

ACE_INLINE TAO_ObjectKey * TAO_DIOP_Profile::_key | ( | void |  | ) | const`[virtual]`

| Return a pointer to the Object Key. The caller owns the memory allocated for the returned key. Reimplemented from TAO_Profile.

void TAO_DIOP_Profile::add_endpoint | ( | TAO_DIOP_Endpoint * | endp | ) |

| Add <end. p> to this profile's list of endpoints (it is inserted next to the head of the list). This profiles takes ownership of <endp>.

void TAO_DIOP_Profile::create_profile_body | ( | TAO_OutputCDR & | encap | ) | const`[private]`

| Creates an encapsulation of the ProfileBody struct in the <cdr>.

IOP::TaggedProfile & TAO_DIOP_Profile::create_tagged_profile | ( | void |  | ) | `[virtual]`

| Please refer to Profile.h for the documentation of this function. Reimplemented from TAO_Profile.

int TAO_DIOP_Profile::decode | ( | TAO_InputCDR & | cdr | ) | `[virtual]`

| Initialize this object using the given CDR octet string. Reimplemented from TAO_Profile.

int TAO_DIOP_Profile::decode_endpoints | ( | void |  | ) | `[private]`

| Helper for <decode>. Decodes endpoints from a tagged component. Decode only if RTCORBA is enabled. Furthermore, we may not find TAO_TAG_ENDPOINTS component, e.g., if we are talking to nonRT version of TAO or some other ORB. This is not an error, and we must proceed. Return 0 on success and -1 on failure.

int TAO_DIOP_Profile::encode | ( | TAO_OutputCDR & | stream | ) | const`[virtual]`

| Encode this profile in a stream, i.e. marshal it. Reimplemented from TAO_Profile.

int TAO_DIOP_Profile::encode_endpoints | ( | void |  | ) | `[virtual]`

| Encodes this profile's endpoints into a tagged component. This is done only if RTCORBA is enabled, since currently this is the only case when we have more than one endpoint per profile. Returns 0 on success and -1 on failure. Endpoints are transmitted using TAO-proprietory tagged component. Component tag is TAO_TAG_ENDPOINTS and component data is an encapsulation of a sequence of structs, each representing a single endpoint. Data format is specified in iiop_endpoins.pidl. Multiple TAG_ALTERNATE_DIOP_ADDRESS components can be used instead of a single proprietory component to transmit multiple endpoints. This is somewhat slower and less convenient. Also, TAG_ALTERNATE_DIOP_ADDRESS does not provide for transmission of endpoint priorities. Reimplemented from TAO_Profile.

TAO_Endpoint * TAO_DIOP_Profile::endpoint | ( | void |  | ) | `[virtual]`

| Return pointer to the head of this profile's endpoints list. Reimplemented from TAO_Profile.

size_t TAO_DIOP_Profile::endpoint_count | ( | void |  | ) | `[virtual]`

| Return how many endpoints this profile contains. Reimplemented from TAO_Profile.

CORBA::ULong TAO_DIOP_Profile::hash | ( | CORBA::ULong max | ACE_ENV_ARG_DECL_NOT_USED | ) | `[virtual]`

| Return a hash value for this object. Reimplemented from TAO_Profile.

CORBA::Boolean TAO_DIOP_Profile::is_equivalent | ( | const TAO_Profile * | other_profile | ) | `[virtual]`

| Return true if this profile is equivalent to other_profile. Two profiles are equivalent iff their tag, object_key, version and all endpoints are the same. Reimplemented from TAO_Profile.

ACE_INLINE const TAO_ObjectKey & TAO_DIOP_Profile::object_key | ( | void |  | ) | const`[virtual]`

| Deprecated: Return a reference to the Object Key. Reimplemented from TAO_Profile.

char TAO_DIOP_Profile::object_key_delimiter | ( | void |  | ) | const`[virtual]`

| Reimplemented from TAO_Profile.

virtual void TAO_DIOP_Profile::parse_string | ( | const char *string | ACE_ENV_ARG_DECL | ) | `[virtual]`

| Initialize this object using the given input string. Url-style string contain only one endpoint. Reimplemented from TAO_Profile.

const char * TAO_DIOP_Profile::prefix | ( | void |  | ) | `[static]`

| Return the char string prefix.

char * TAO_DIOP_Profile::to_string | ( | ACE_ENV_SINGLE_ARG_DECL |  | ) | `[virtual]`

| Return a string representation for this profile. client must deallocate memory. This is used to create url-style reference. Only one endpoint is included into the string. Reimplemented from TAO_Profile.

## Member Data Documentation

size_t TAO_DIOP_Profile::count_`[protected]`

| Number of endpoints in the list headed by <endpoint_>.

TAO_DIOP_Endpoint TAO_DIOP_Profile::endpoint_`[protected]`

| Head of this profile's list of endpoints. This endpoint is not dynamically allocated because a profile always contains at least one endpoint. Currently, a profile contains more than one endpoint, i.e., list contains more than just the head, only when RTCORBA is enabled. However, in the near future, this will be used in nonRT mode as well, e.g., to support TAG_ALTERNATE_DIOP_ADDRESS feature. Addressing info of the default endpoint, i.e., head of the list, is transmitted using standard DIOP ProfileBody components. See <encode_endpoints> method documentation above for how the rest of the endpoint list is transmitted.

TAO_ObjectKey TAO_DIOP_Profile::object_key_`[private]`

| Object_key associated with this profile.

const char TAO_DIOP_Profile::object_key_delimiter_ = '/'`[static]`

| The object key delimiter that DIOP uses or expects.

IOP::TaggedProfile TAO_DIOP_Profile::tagged_profile_`[private]`

| Our tagged profile.

The documentation for this class was generated from the following files:

- DIOP_Profile.h
- DIOP_Profile.cpp
- DIOP_Profile.i